<!DOCTYPE html>
<html lang="fr">
<head>
  <title>Présentation projet : groupe 5</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js"></script>
  <style>
    figure {
      border: 1px #cccccc solid;
      padding: 4px;
      margin: auto;
    }
    
    figcaption {
      background: rgba(0,0,0,0.7);
      color: white;
      font-style: italic;
      padding: 2px;
      text-align: center;
    }
    </style>
</head>
<body>

<div class="container-fluid p-5 bg-primary text-white text-center">
  <h1>Voyageur de commerce</h1>
  <p>Groupe 05 : Lucas LARZILLIERE, Tristan VILLETTE, Florian GAVA</p>
  <a href='groupe.html' class="row-sm-4 ">
    <button type="button" class="btn btn-secondary">Retour</button>
  </a>
</div>
  
<div class="container mt-5">
    <div class="col">
      <div class="row-sm-4">
        <h3>Présentation générale</h3>
        <p>Nous avons séparés notre groupe de projet en trois parties : algorithme glouton, algotihme des fourmies et partie graphique. Ces trois parties ont été codées en parallèle.
          Avant de commencer, nous avons codé différentes méthodes pour générer des graphes avec des arcs de poids 1 afin de plus tard générer le vrai graphe avec comme poids les coordonnées euclidiennes.
          Le choix de ces deux algorithmes a permis d'avoir un point de vue différent sur le même problème du voyageur de commerce.
        </p>
      </div>
      <div class="row-sm-4">
        <h3>Partie 1 : Floyd-Warshall</h3>
        <h6>La première étape avant d'attaquer les algorithmes</h6>
        <p>La première chose à faire pour se lancer dans les algorithmes était de coder la méthode de Floyd-Warshall. Elle a pris peu de temps, ce qui a permis de vite avancer sur les algorithmes d'optimisation
          pendant qu'un autre travaillait sur la partie graphique. On se retrouve donc avec une matrice symétrique représentant la distance à parcourir entre chaque point en coordonnées euclidiennes.
        </p>
        <figure>
            <img src="img/FW.png" width="400" height="200">
            <figcaption>Rendu console de la méthode de Floyd-Warshall</figcaption>
        </figure>
      </div>
      <div class="row-sm-4">
        <h3>Partie 2 : Glouton exhaustif (aléatoire)</h3>
        <h6>Premier algorithme</h6>
        <p>La méthode du glouton exhaustif aléatoire permet de prendre soit le meilleur chemin la plupart du temps, soit un autre chemin avec une faible probabilité le reste du temps. L'algorihme fonctionne dans le terminal avec les bonnes matrices mais n'est pas pris en charge par l'implémentation graphique en SDL2.
          Cet algorithme renvoie le meilleur chemin ainsi que la distance à parcourir.
        </p>
        <figure>
            <img src="img/glouton.png">
            <figcaption>Rendu console de la méthode glouton exhaustif</figcaption>
        </figure>
      </div>
      <div class="row-sm-4">
        <h3>Partie 3 : Fourmis</h3>        
        <h6>Deuxième algorihme</h6>
        <p>L'algorithme des fourmis est celui qui a demandé le plus de temps car plus compliqué à implémenter en C. Tout comme le glouton exhaustif, l'algorithme fonctionne dans le terminal mais ne s'applique pas au graphe affiché par la SDL2. Cet algorithme renvoie le meilleur chemin.</p>
        <figure>
            <img src="img/fourmies.png" width="1000" height="200">
            <figcaption>Rendu console de la méthode des fourmis</figcaption>
        </figure>
      </div>
      <div class="row-sm-4">
        <h3>Partie 4 : Graphique</h3>        
        <h6>Fait avec SDL2</h6>
        <p>Avant de commencer la SDL2, on a d'abord décider de coder une représentation dans le terminal afin de vérifier les matrices sans consommer beaucoup de temps.
          Le code du graphe s'est fait en plusieurs parties. D'abord, il y a eu la génération aléatoire des points, la génération du poids des arêtes en coordonnées euclidiennes ainsi que la partie cliquable.
          Sur la partie graphique, on a le numéro des sommets qui sont affichés ainsi que les distances en coordonnées euclidiennes.
        </p>
        <figure>
            <img src="img/graphe.png" width="400" height="400">
            <figcaption>Graphe avant que l'utilisateur ait cliqué</figcaption>
        </figure>
        <p>La partie cliquable permet uniquement d'afficher des carrés oranges lorsque l'utilisateur clique sur un sommet. L'objectif était de permettre à l'utilisateur de lier des sommets mais nous sommes passés à la partie jeu d'arcade pour le temps qu'il restait.</p>
        <figure>
            <img src="img/grapheclick.png" width="400" height="400">
            <figcaption>Graphe après que l'utilisateur ait cliqué</figcaption>
        </figure>
      </div>
    </div>
  </div>

</body>
</html>
